<?php 
require_once (MODULE_REALDIR . "mdl_dchk/const.php");

class LC_Helper_Mdl_Dchk{

    function LC_Helper_Mdl_Dchk(){
    
    }
    
    function setConfig(&$objFormParam) {
        $objQuery =& SC_Query_Ex::getSingletonInstance();
        $sqlval = array();
        $arrConfig = $objFormParam->getHashArray();
        $sqlval['sub_data'] = serialize($arrConfig);
        $objQuery->update("dtb_module", $sqlval, "module_code = ?", array("mdl_dchk"));
    }

    function getConfig() {
        $objQuery =& SC_Query_Ex::getSingletonInstance();
        $arrRet = $objQuery->select("sub_data", "dtb_module", "module_code = ?", array("mdl_dchk"));
        $arrConfig = unserialize($arrRet[0]['sub_data']);
        return $arrConfig;
    }

    function getConvenienceArray(){
        global $DCHK_CONVENIENCE_ARRAY;
        return $DCHK_CONVENIENCE_ARRAY;
    }
    
    function getPaymentArray(){
        global $DCHK_PAYMENT_ARRAY;
        return $DCHK_PAYMENT_ARRAY;
    }

    function getLimitDateArray(){
        global $DCHK_LIMITDATE_ARRAY;
        return $DCHK_LIMITDATE_ARRAY;
    }    

    function log($msg, $data = null, $suffix = '') {
        $path = DATA_REALDIR . "logs/mdl_dchk" . "$suffix.log";
        GC_Utils_Ex::gfPrintLog($msg, $path);

        if (!is_null($data)) {
            GC_Utils_Ex::gfPrintLog(print_r($data, true), $path);
        }
    }

    function getTemplateDir($tpl_file) {
        switch (SC_Display::detectDevice()) {
        case DEVICE_TYPE_MOBILE:
            $dir = 'mobile/'; 
            break;
        case DEVICE_TYPE_SMARTPHONE:
            $dir = 'sphone/';
            break;
        default:
            $dir = 'pc/';
            break;
        }

        return MODULE_REALDIR . "mdl_dchk/templates/".$dir . $tpl_file;
    }

    function POST($target,$arrSendData){
        if(!ini_get("allow_url_fopen")){
            LC_Helper_Mdl_Dchk::log('fsockopenでデータ送信');
            $target = parse_url($target);
            $res = "";
            $fp = fsockopen("ssl://".$target["host"], 443, $errno, $errstr, 60);
            if (!$fp) {
                $this->arrErr +=array("message"=> "エラーが発生しました：".$errstr);
                LC_Helper_Mdl_Dchk::log("エラーが発生しました：".$errstr);
            } else {
                $out =   "POST ".$target["path"]." HTTP/1.1\r\n"
                        ."Host: ".$target["host"]."\r\n"
                        ."Path: ".$target["path"]."\r\n"
                        ."Content-type: application/x-www-form-urlencoded\r\n"
                        ."Content-length: " . strlen(http_build_query($arrSendData)) . "\r\n"                                    
                        ."Connection: close\r\n"
                        ."\r\n".http_build_query($arrSendData)."\r\n";
                fwrite($fp, $out);
                LC_Helper_Mdl_Dchk::log("送信データ：".$out);
                while (!feof($fp)) {
                    $res .= fgets($fp, 4096);
                }
                fclose($fp);
                LC_Helper_Mdl_Dchk::log("受信データ：".$res);
                $res = explode("\r\n\r\n",$res);
                unset($res[0]);
                $res = implode("\r\n\r\n",$res);
            }
        }else{
            LC_Helper_Mdl_Dchk::log('file_get_contentsでデータ送信');
            $options = array('http' => array(
                'method' => 'POST',
                'content' => http_build_query($arrSendData),
            ));
            LC_Helper_Mdl_Dchk::log("送信データ：".mb_convert_encoding(print_r($arrSendData,1),"UTF-8","SJIS"));
            $res = file_get_contents($target,false,stream_context_create($options));
            LC_Helper_Mdl_Dchk::log("受信データ：".mb_convert_encoding($res,"UTF-8","SJIS"));
        }
        return $res;
    }
    
    function sendRedirect($url, $arrQueryString = array()) {

        $netUrl = new Net_URL($url);
        $arrQueryString = array_merge($netUrl->querystring, $arrQueryString);
        $netUrl->querystring = array();

        foreach ($arrQueryString as $key => $val) {
            $netUrl->addQueryString($key, $val);
        }

        $url = $netUrl->getURL();

        header("Location: $url");
        exit;
    }

    function remoteIpCheck($remote_addr, $allow_addr_range)
    {
        $arr = explode("/", $allow_addr_range);
        if (count($arr) != 2)
        {
            return false;
        }
        if ( ((ip2long($remote_addr)>>(32-$arr[1])) ^ (ip2long($arr[0])>>(32-$arr[1]) )) == 0)
        {
            return true;
        } else {
            return false;
        }
    }

}